function out = fss_hrmonic( f_min, f_max, f_step, A, B, a, b, M, N, P, Q, current_check, mod_check, phase_check,polar, krok_x, krok_y, th, fi, t, db_check, krok_I);


iM = M + 1;
iN = N + 1;

num_f = round( abs( f_max - f_min) / f_step);

for st=0:num_f     
  
  f   = (f_min + st*f_step)*1e+9;                                                  % aktuln kmitoet
  om  = 2*pi*f;                                                                    % hlov kmitoet
  k   = om / 3e+8;                                                                 % vln. slo ve smru en
   
  al0 = k*sin(th)*cos(fi);                                                         % prumet vlnoveho cisla do smeru x
  bt0 = k*sin(th)*sin(fi);                                                         % prumet vlnoveho cisla do smeru y
  
  al = al0*ones(1,iM+M) + 2*pi*(-M:M)/A;                                           % vy prostorov harmonick
  bt = bt0*ones(1,iN+N) + 2*pi*(-N:N)/B;                                           
  [ksi_TE, psi_TE, ksi_TM, psi_TM] = mk_psi( M, N, P, Q, a, A, b, B);              % Fourierovy obrazy bzovch fc
  K  = mk_k( k, al, bt, M, N);                                                     % Fourierieruv obraz Greenovy fce
  
  sz = P*Q + (P+1)*(Q+1) - 1;                                                      % pocet rovnic N, pro N neznamych koeficientu
  L  = zeros( sz, sz);
  
  row = 0;
  
  for r=0:P
    for s=0:Q
      if (r~=0) | (s~=0)
        row = row + 1;
        col = 0;
        for p=1:P
          for q=1:Q
            col = col + 1;
            for m=-M:M
              for n=-N:N
                hlp = conj( ksi_TE( :,iM+m,iN+n,r+1,s+1))'*K( :,:,iM+m,iN+n)*psi_TM( :,iM+m,iN+n,p+1,q+1);
                L( row,col) = L( row,col) + hlp;
              end
            end
          end
        end
        for p=0:P
          for q=0:Q
            if (p~=0) | (q~=0)
              col = col + 1;
              for m=-M:M
                for n=-N:N
                  hlp = conj( ksi_TE( :,iM+m,iN+n,r+1,s+1))'*K( :,:,iM+m,iN+n)*psi_TE( :,iM+m,iN+n,p+1,q+1);
                  L( row,col) = L( row,col) + hlp;
                end
              end
            end
          end
        end
      end
    end
  end
  
  for r=1:P
    for s=1:Q
      row = row + 1;
      col = 0;
      for p=1:P
        for q=1:Q
          col = col + 1;
          for m=-M:M
            for n=-N:N
              hlp = conj( ksi_TM( :,iM+m,iN+n,r+1,s+1))'*K( :,:,iM+m,iN+n)*psi_TM( :,iM+m,iN+n,p+1,q+1);
              L( row,col) = L( row,col) + hlp;
            end
          end
        end
      end
      for p=0:P
        for q=0:Q
          if (p~=0) | (q~=0)
            col = col + 1;
            for m=-M:M
              for n=-N:N
                hlp = conj( ksi_TM( :,iM+m,iN+n,r+1,s+1))'*K( :,:,iM+m,iN+n)*psi_TE( :,iM+m,iN+n,p+1,q+1);
                L( row,col) = L( row,col) + hlp;
              end
            end
          end
        end
      end
    end
  end
  
  R = zeros( sz, 1);                                                                % vypocet prave strany vychozi rovnice numericke analyzy
  
  col = 0;
  for r=0:P
    for s=0:Q
      if (r~=0) | (s~=0)
        col = col + 1;
        R( col) = b*sinc( s*pi) * ( 1 - cos( r*pi)) + a*sinc(r*pi)*(1 - cos(s*pi));
      end
    end
  end
  R = 2*om*8.85e-12 * R;

  F = inv(L)*R;
  J = zeros( 2, 1);
  
  col = 0;
  for p=1:P
    for q=1:Q
      col = col + 1;
      J = J + F( col)*psi_TM(:,iM,iN,p+1,q+1);
    end
  end
  
  for p=0:P
    for q=0:Q
      if (p~=0) | (q~=0)
        col = col + 1;
        J = J + F( col)*psi_TE(:,iM,iN,p+1,q+1);
      end
    end
  end

 if (current_check == 1) 
     C_dist2(F, P, Q, a, A, b, B, st, f_step, krok_x, krok_y, krok_I, polar);
 end;
  
  Es = - K( :, :, iM, iN) * J(:) / (2*om*8.85e-12);
  
  out( st+1, 1) = f*1e-9;
    
if (fi ~= pi/2) 
if (polar == 1)
  out( st+1, 2) = abs(Es(1)*cos(fi)^2);
  out( st+1, 3) = 180*angle(Es(1))/pi;
  out( st+1, 4) = 20*log10(1-abs( Es(1)));
else
   out( st+1, 2) = abs(Es(2)*cos(fi)^2);
   out( st+1, 3) = 180*angle(Es(2))/pi;
   out( st+1, 4) = 20*log10(1-abs(Es(2)));
end;
else 
  if (polar == 1)
  out( st+1, 2) = abs(Es(2)*sin(fi)^2);
  out( st+1, 3) = 180*angle(Es(2))/pi;
  out( st+1, 4) = 20*log10(1-abs( Es(2)));
else
   out( st+1, 2) = abs(Es(1)*sin(fi)^2);
   out( st+1, 3) = 180*angle(Es(1))/pi;
   out( st+1, 4) = 20*log10(1-abs(Es(1)));
end;
end

x = out( :, 1)';
y = out( :, 2)';
z = out( :, 3)';
w = out( :, 4)';

if (mod_check == 1) 
    figure(1);
    plot(x,y);
    title('modul cinitele odrazu');
end;

if (phase_check == 1) 
    figure(2);
    plot(x,z);
    title('faze cinitele odrazu');
end;

if (db_check == 1) 
    figure(3);
    plot(x,w);
    title('modul cinitele prostupu v dB');
end;


end
et = etime(clock,t)
